﻿Public Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        GridView1.DataSource = GetTableData()
        DataBind()
    End Sub

    Protected Sub GridView1_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles GridView1.RowDataBound

        If e.Row.RowType = DataControlRowType.DataRow Then

            Dim dr As DataRowView = e.Row.DataItem
            Dim qty As Integer = dr("Qty")
            Dim price As Decimal = dr("Price")
            Dim totalPrice = qty * price

            Dim litTotalPrice As Literal = DirectCast(e.Row.FindControl("litTotalPrice"), Literal)
            Dim litQty As Literal = DirectCast(e.Row.FindControl("litQty"), Literal)

            If (litQty IsNot Nothing) Then
                litQty.Text = qty.ToString()
            End If

            If (litTotalPrice IsNot Nothing) Then
                litTotalPrice.Text = totalPrice.ToString("c")
            End If
        End If

        If e.Row.RowType = DataControlRowType.Footer Then

            Dim qty As Integer
            Dim price As Decimal

            GetTableTotals(qty, price)

            Dim litSumTotalPrice As Literal = DirectCast(e.Row.FindControl("litSumTotalPrice"), Literal)
            Dim litSumQty As Literal = DirectCast(e.Row.FindControl("litSumQty"), Literal)

            If (litSumQty IsNot Nothing) Then
                litSumQty.Text = qty.ToString()
            End If

            If (litSumTotalPrice IsNot Nothing) Then
                litSumTotalPrice.Text = price.ToString("c")
            End If
        End If
    End Sub

    Function GetTableData() As DataTable

        Dim dt As New DataTable()
        Dim dr As DataRow

        dt.Columns.Add("Description", System.Type.GetType("System.String"))
        dt.Columns.Add("Price", System.Type.GetType("System.Decimal"))
        dt.Columns.Add("Qty", System.Type.GetType("System.Int32"))

        For index As Integer = 1 To 10
            dr = dt.NewRow()
            dr("Description") = String.Concat("Item #", index)
            dr("Price") = index
            dr("Qty") = index

            dt.Rows.Add(dr)
        Next

        Return dt
    End Function

    Sub GetTableTotals(ByRef qty, ByRef price)

        Dim dt As DataTable = GridView1.DataSource
        Dim rows = dt.AsEnumerable()

        qty = rows.Sum(Function(p) p("Qty"))
        price = (From n In rows Select n.Field(Of Integer)("Qty") * n.Field(Of Decimal)("Price")).Sum()
    End Sub
End Class